/*
 * PacketReader.java
 *
 * Created on December 12, 2008, 7:11 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package vpn;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.ObjectInputStream;
import java.security.Key;
import java.security.Security;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import javax.crypto.Cipher;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

/**
 *
 * @author cchrysler
 */
public class PacketReader implements Runnable {

    String srcIp, payLoad, loginInstance;

    /** Creates a new instance of PacketReader */
    public PacketReader(String ip, String udpPayload) {
        srcIp = ip;
        payLoad = udpPayload;
    }

    private Map getUserKeyMap(String fileLocation) throws Exception {
        Map<String, String> map = new HashMap();
        BufferedReader bfr = new BufferedReader(new FileReader(fileLocation));
        while (bfr.ready()) {
            StringBuffer sb = new StringBuffer();
            String line = bfr.readLine();
            String[] sa = line.split("=");
            map.put(sa[0], sa[1]);
        }
        bfr.close();
        return map;
    }


    private String byteArrayToString(byte[] buffer) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < buffer.length; i++) {
            sb.append((char) buffer[i]);
        }
        return sb.toString();
    }

    private String parseTime(Long time) {

        DateFormat df = new SimpleDateFormat("MM.dd.yyyy - HH:mm:ss");
        Calendar calendar = Calendar.getInstance();
        calendar.setTimeInMillis(time);
        return df.format(calendar.getTime());
    }

    public void run() {
        try {

            ConfBean cb = ConfBean.getInstance();

            SimpleLogger logger = SimpleLogger.getInstance();//use log4J, or find out why this isnt working

            Security.addProvider(new BouncyCastleProvider());

            Map<String, String> map = getUserKeyMap(/*"/opt/users/userKeyMap"*/cb.getFileLocationOfUserMap());//use database, or set permissions tight on txt file//parameterized from conf

            int payLoadLength = payLoad.length();
            String innerPayLoad = payLoad.substring(0, payLoadLength / 2);
            String outerPayLoad = payLoad.substring(payLoadLength / 2, payLoadLength);

            byte[] outerPayLoadArray = new byte[outerPayLoad.length() / 2];
            for (int i = 0; i < outerPayLoadArray.length; i++) {
                outerPayLoadArray[i] = (byte) Integer.parseInt(outerPayLoad.substring(2 * i, 2 * i + 2), 16);
            }

            Key outerPrivKey, innerPrivKey;

            ObjectInputStream in = new ObjectInputStream(
                    new FileInputStream(cb.getFileLocationOfOuterPrivKey() +
                    "/" + cb.getNameOfMasterPrivKey()));// lock file permission or maybe read from db//parameterized from conf
            outerPrivKey = (Key) in.readObject();
            in.close();

            Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding", "BC");
            cipher.init(Cipher.DECRYPT_MODE, outerPrivKey);
            byte[] plainText = cipher.doFinal(outerPayLoadArray);

            String authAttempt = byteArrayToString(plainText);

            if (map.containsKey(authAttempt)) {//outerKey auth success

                byte[] innerPayLoadArray = new byte[innerPayLoad.length() / 2];
                for (int i = 0; i < innerPayLoadArray.length; i++) {
                    innerPayLoadArray[i] = (byte) Integer.parseInt(innerPayLoad.substring(2 * i, 2 * i + 2), 16);
                }

                ObjectInputStream innerKeyStream = new ObjectInputStream(
                        new FileInputStream(map.get(authAttempt)));
                innerPrivKey = (Key) innerKeyStream.readObject();
                innerKeyStream.close();

                cipher.init(Cipher.DECRYPT_MODE, innerPrivKey);
                byte[] innerText = cipher.doFinal(innerPayLoadArray);
                String innerAuthAttempt = byteArrayToString(innerText);
                //System.out.println("keyPhrase + timestamp = " + innerAuthAttempt);


                String[] saInner = innerAuthAttempt.split("_");
                Long time = new Long(saInner[1]);
                int allowanceTime = Integer.parseInt(cb.getClockDriftAllowance() + "000");
                Long limit = System.currentTimeMillis() - (allowanceTime * 60);//(5000 * 60);//parameterized from conf
                //System.out.println("received time =  " + parseTime(time));
                //System.out.println("limit =  " + parseTime(limit));


                if (saInner[0].equals("YouSuck!") && time >= limit) {//inner auth success

                    //System.out.println("successful login: true");
                    loginInstance = "\nuserName=" + authAttempt + "\n";
                    loginInstance += "srcIP=" + srcIp + "\n";
                    loginInstance += "successfullLogin=true\n";
                    //loginInstance += "keyPhrase+timestamp=" + innerAuthAttempt + "\n";
                    loginInstance += "receivedTime=" + parseTime(time) + "\n";
                    loginInstance += "limitTime=" + parseTime(limit) + "\n";
                    logger.logMessage(loginInstance);

                    //probably should delete first so multiple entries arent added

                    String[] commandDeleteInit = {"sh" , "-c" , "/sbin/iptables -D INPUT -i " + cb.getInterfaceOfListener() /*" eth0 "*/ + " -s " + srcIp + 
                            " -p tcp --dport " + cb.getSshServerPort() + " -m state --state NEW,ESTABLISHED,RELATED -j ACCEPT"};
                    final Process processDeleteInit = Runtime.getRuntime().exec(commandDeleteInit);
                    processDeleteInit.waitFor();
                    
                    String[] commandInsert = {"sh" , "-c" , "/sbin/iptables -I INPUT -i " + cb.getInterfaceOfListener() /*" eth0 "*/ + " -s " + srcIp + 
                            " -p tcp --dport " + cb.getSshServerPort() + " -m state --state NEW,ESTABLISHED,RELATED -j ACCEPT"};
                    final Process processInsert = Runtime.getRuntime().exec(commandInsert);
                    processInsert.waitFor();
                    
                    Thread.currentThread().sleep(1000 * Integer.parseInt(cb.getOpenPortAllowanceTime()));//60);//parameterized from conf
                    
                    String[] commandDelete = {"sh" , "-c" , "/sbin/iptables -D INPUT -i " + cb.getInterfaceOfListener() /*" eth0 "*/ + " -s " + srcIp + 
                            " -p tcp --dport " + cb.getSshServerPort() + " -m state --state NEW,ESTABLISHED,RELATED -j ACCEPT"};
                    final Process processDelete = Runtime.getRuntime().exec(commandDelete);
                    processDelete.waitFor();

                } else {
                    //System.out.println("innerKey auth fail: " + saInner[0] + "\n");
                    loginInstance = "\nuserName=" + authAttempt + "\n";
                    loginInstance += "srcIP=" + srcIp + "\n";
                    loginInstance += "successfullLogin=false\n";
                    loginInstance += "innerKeyAuthFail=" + saInner[0] + "\n";
                    logger.logMessage(loginInstance);
                }
            } else {
                //System.out.println("outerKey auth fail: " + authAttempt + "\n");
                loginInstance = "\nuserName=" + authAttempt + "\n";
                loginInstance += "srcIP=" + srcIp + "\n";
                loginInstance += "successfullLogin=true\n";
                loginInstance += "outerKeyAuthFail=" + authAttempt + "\n";
                logger.logMessage(loginInstance);
            }

            

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public static void main(String[] args) {
        Thread t = new Thread(new PacketReader(args[0], args[1]));
        t.start();
    }
}
