

package spa;

import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.security.Key;
import java.security.Security;
import javax.crypto.Cipher;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

/**
 *
 * @author chris.chrysler
 */
public class UDPPacketAuthStandAlone implements Runnable{
    
    protected static String sourceIP , outerKeyFileLocation , innerKeyFileLocation ,
            userName, sourcePort , dstPort, dstIP;
    /** Creates a new instance of UDPPacketPubKey */
    public UDPPacketAuthStandAlone() {
    }
    
    public UDPPacketAuthStandAlone(String _sourceIP , String _outerKeyFileLocation,
            String _innerKeyFileLocation, String _userName, String _sourcePort, 
            String _dstPort, String _dstIP) {
        sourceIP = _sourceIP;
        outerKeyFileLocation = _outerKeyFileLocation;
        innerKeyFileLocation = _innerKeyFileLocation;
        userName = _userName;
        sourcePort = _sourcePort;
        dstPort = _dstPort;
        dstIP = _dstIP;
    }
    
    private void printBytesAsHex(byte[] buffer) {
        for (int i = 0; i < buffer.length; i++) {
            System.out.print(toHexString(buffer[i], 2));
        }
        System.out.println();
    }
        
    
    private String toHexString(long n, int length) {
        String result = "";
        for (int i = 0; i < length; i++) {
            result = Integer.toHexString(((int) n) & 0xF) + result;
            n >>>= 4;
        }
        return result;
    }
    
    public void run(){
        try {
            Security.addProvider(new BouncyCastleProvider());
            Key outerPubKey , innerPubKey;
            ObjectInputStream in = new ObjectInputStream(
                        new FileInputStream(innerKeyFileLocation));
            innerPubKey = (Key) in.readObject();
            in.close();
            String innerText = "YouSuck!_" + System.currentTimeMillis();
            
            //encrypt payload with inner key
            byte[] input = innerText.getBytes();
            Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding", "BC");//("RSA");
            cipher.init(Cipher.ENCRYPT_MODE, innerPubKey);
            byte[] cipherTextInner = cipher.doFinal(input);
            
            //encrypt outerkey payload
            ObjectInputStream outerKeyStream = new ObjectInputStream(
                        new FileInputStream(outerKeyFileLocation));
            outerPubKey = (Key) outerKeyStream.readObject();
            outerKeyStream.close();
            String outerText = userName;
            System.out.println("outerText4 = " + outerText);
            byte[] outerBA = outerText.getBytes();
            cipher.init(Cipher.ENCRYPT_MODE, outerPubKey);
            byte[] cipherTextOuter = cipher.doFinal(outerBA);
            
            byte[] baToSend = new byte[cipherTextInner.length + cipherTextOuter.length];
            System.arraycopy(cipherTextInner, 0 , baToSend , 0 , cipherTextInner.length);
            System.arraycopy(cipherTextOuter , 0 , baToSend , cipherTextInner.length,
                    cipherTextOuter.length);
                 
            DatagramSocket ds = 
                    new DatagramSocket(Integer.parseInt(sourcePort),
                    InetAddress.getByName(sourceIP));
            DatagramPacket packet = 
                    new DatagramPacket(baToSend , baToSend.length ,
                    InetAddress.getByName(dstIP), Integer.parseInt(dstPort));
            ds.send(packet);
            ds.close();
            System.out.print("sending: ");
            printBytesAsHex(baToSend);
       
        } catch (Exception e){
            e.printStackTrace();
        }
    }
    
    public static void main(String[] args){
        Thread t = new Thread(new UDPPacketAuthStandAlone(args[0] , args[1] , 
                args[2] , args[3], args[4] , args[5], args[6]));
        t.start();
    }
}
